/* This program blinks a led without the use of the delay function
 * it uses the millis() fucntion for timing instead.
 * Software coding Jan Rouvroye for website E-lab multitasking Arduino.
 * Last edit: Sep 9, 2015
 */

// using preprocessor commands for settings
#define LED_PIN 13                 // pin where led is connected 
#define LED_OFF 0
#define LED_ON 1
#define LED_OFF_TIME 1000          // period in ms the led is off 
#define LED_ON_TIME 100            // period in ms the led is on 

// declarations
int ledState;      // variable indicating the state of the led, either LED_OFF or LED_ON
unsigned long ledPeriod;           // variabele storing on or off period in ms
unsigned long startTime;           // current time in ms when starting new on or off period

void setup() {
  pinMode(LED_PIN, OUTPUT);

  ledState = LED_OFF;              // initial state is LED_OFF
  ledPeriod = LED_OFF_TIME;        // initialize period for LED_OFF state
  startTime = millis();            // store time when period starts
}

void loop() {
  ledStep();
}

void ledStep() {
  switch (ledState) {
    case LED_ON:
      digitalWrite(LED_PIN, HIGH);

      if (millis() - startTime > ledPeriod)    // change to LED_OFF state
      {
        ledState = LED_OFF;
        ledPeriod = LED_OFF_TIME;   // initialize timer for LED_OFF state
        startTime = millis();             // store time when new period starts
      }
      break;

    case LED_OFF:
      digitalWrite(LED_PIN, LOW);

      if (millis() - startTime > ledPeriod)    // change to LED_ON state
      {
        ledState = LED_ON;
        ledPeriod = LED_ON_TIME;   // initialize timer for LED_ON state
        startTime = millis();      // store time when new period starts
      }
      break;
  }
}

